// deno-lint-ignore-file
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var _AsyncQueue_unconsumedValues, _AsyncQueue_unconsumedPromises, _AsyncQueue_signal, _AsyncQueue_error, _AsyncQueue_finished, _AsyncQueue_errorHandler, _AsyncQueue_abortListener;
function newAbortError() {
    return new DOMException('eventTargetToAsyncIter was aborted via AbortSignal', 'AbortError');
}
export class AsyncQueue {
    constructor(options) {
        _AsyncQueue_unconsumedValues.set(this, []);
        _AsyncQueue_unconsumedPromises.set(this, []);
        _AsyncQueue_signal.set(this, void 0);
        _AsyncQueue_error.set(this, null);
        _AsyncQueue_finished.set(this, false);
        _AsyncQueue_errorHandler.set(this, (err) => {
            __classPrivateFieldSet(this, _AsyncQueue_finished, true, "f");
            const toError = __classPrivateFieldGet(this, _AsyncQueue_unconsumedPromises, "f").shift();
            if (toError) {
                toError.reject(err);
            }
            else {
                // The next time we call next()
                __classPrivateFieldSet(this, _AsyncQueue_error, err, "f");
            }
            this.return();
        });
        _AsyncQueue_abortListener.set(this, () => {
            __classPrivateFieldGet(this, _AsyncQueue_errorHandler, "f").call(this, newAbortError());
        });
        const signal = options === null || options === void 0 ? void 0 : options.signal;
        if (signal === null || signal === void 0 ? void 0 : signal.aborted)
            throw newAbortError();
        if (__classPrivateFieldGet(this, _AsyncQueue_signal, "f")) {
            __classPrivateFieldGet(this, _AsyncQueue_signal, "f").addEventListener('abort', __classPrivateFieldGet(this, _AsyncQueue_abortListener, "f"), { once: true });
        }
        __classPrivateFieldSet(this, _AsyncQueue_signal, signal, "f");
    }
    push(el) {
        const promise = __classPrivateFieldGet(this, _AsyncQueue_unconsumedPromises, "f").shift();
        if (promise) {
            promise.resolve({ value: el, done: false }); // FIXME
        }
        else {
            __classPrivateFieldGet(this, _AsyncQueue_unconsumedValues, "f").push(el); // FIXME
        }
    }
    // TODO: does it make sense/is it possible to add `shift` / `pop`??
    /** Alias for `next` */
    unshift() {
        return this.next();
    }
    next() {
        // First, we consume all unread events
        const value = __classPrivateFieldGet(this, _AsyncQueue_unconsumedValues, "f").shift();
        if (value) {
            return Promise.resolve({ value, done: false });
        }
        // Then we error, if an error happened
        // This happens one time if at all, because after 'error'
        // we stop listening
        if (__classPrivateFieldGet(this, _AsyncQueue_error, "f")) {
            const p = Promise.reject(__classPrivateFieldGet(this, _AsyncQueue_error, "f"));
            // Only the first element errors
            __classPrivateFieldSet(this, _AsyncQueue_error, null, "f");
            return p;
        }
        // If the iterator is finished, resolve to done
        if (__classPrivateFieldGet(this, _AsyncQueue_finished, "f")) {
            return Promise.resolve({ value: undefined, done: true });
        }
        // Wait until an event happens
        return new Promise((resolve, reject) => {
            __classPrivateFieldGet(this, _AsyncQueue_unconsumedPromises, "f").push({ resolve, reject });
        });
    }
    return() {
        if (__classPrivateFieldGet(this, _AsyncQueue_signal, "f")) {
            __classPrivateFieldGet(this, _AsyncQueue_signal, "f").removeEventListener('abort', __classPrivateFieldGet(this, _AsyncQueue_abortListener, "f"));
        }
        __classPrivateFieldSet(this, _AsyncQueue_finished, true, "f");
        for (const promise of __classPrivateFieldGet(this, _AsyncQueue_unconsumedPromises, "f")) {
            promise.resolve({ value: undefined, done: true });
        }
        return Promise.resolve({ value: undefined, done: true });
    }
    throw(err) {
        // if (!err || !(err instanceof Error)) {
        //   throw new ERR_INVALID_ARG_TYPE('EventEmitter.AsyncIterator',
        //                                  'Error', err);
        // }
        __classPrivateFieldSet(this, _AsyncQueue_error, err, "f");
        return Promise.reject(err);
    }
    [(_AsyncQueue_unconsumedValues = new WeakMap(), _AsyncQueue_unconsumedPromises = new WeakMap(), _AsyncQueue_signal = new WeakMap(), _AsyncQueue_error = new WeakMap(), _AsyncQueue_finished = new WeakMap(), _AsyncQueue_errorHandler = new WeakMap(), _AsyncQueue_abortListener = new WeakMap(), Symbol.asyncIterator)]() {
        return this;
    }
}
//# sourceMappingURL=async-queue.js.map