"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ND_JSONStringifyStream = exports.JSONStringifyStream = void 0;
// deno-lint-ignore-file no-explicit-any
const resolvable_promise_1 = require("@worker-tools/resolvable-promise");
const json_stringify_js_1 = require("./json-stringify.js");
class JSONStringifyStream extends TransformStream {
    constructor() {
        let first;
        let done;
        super({
            start(controller) {
                first = true;
                controller.enqueue('[');
            },
            async transform(obj, controller) {
                done = new resolvable_promise_1.ResolvablePromise();
                try {
                    for await (const chunk of (0, json_stringify_js_1.jsonStringifyGenerator)(obj)) {
                        if (!first)
                            controller.enqueue(',');
                        else
                            first = false;
                        controller.enqueue(chunk);
                    }
                }
                finally {
                    done.resolve();
                }
            },
            async flush(controller) {
                await done; // FIXME: good idea?
                controller.enqueue(']');
            }
        });
    }
}
exports.JSONStringifyStream = JSONStringifyStream;
/** @deprecated Untested */
class ND_JSONStringifyStream extends TransformStream {
    constructor() {
        super({
            async transform(obj, controller) {
                for await (const chunk of (0, json_stringify_js_1.jsonStringifyGenerator)(obj)) {
                    controller.enqueue(chunk);
                    controller.enqueue('\n');
                }
            },
        });
    }
}
exports.ND_JSONStringifyStream = ND_JSONStringifyStream;
//# sourceMappingURL=json-stringify-stream.js.map