export interface AsyncQueueOptions {
    /**
     * An abort signal to cancel async iteration.
     */
    signal?: AbortSignal;
}
export declare class AsyncQueue<T = any> implements AsyncIterableIterator<T> {
    #private;
    constructor(options?: AsyncQueueOptions);
    push(el: T): void;
    /** Alias for `next` */
    unshift(): Promise<IteratorResult<T, void>>;
    next(): Promise<IteratorResult<T, void>>;
    return(): Promise<IteratorResult<T, void>>;
    throw(err: any): Promise<IteratorResult<T, void>>;
    [Symbol.asyncIterator](): AsyncGenerator<T>;
}
